﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Karpach.Samples.AnimalFabric.Interfaces;
using Karpach.Samples.AnimalFabric.Entities;

namespace Karpach.Samples.AnimalFabric.DefaultFactories
{
    public class DefaultFactory
    {
        public static T Create<T>()
        {
            if (typeof(T) == typeof(IDog))
            {
                return (T)(IDog)new Dog();
            }
            else
                if (typeof(T) == typeof(ICat))
                {
                    return (T)(ICat)new Cat();
                }
                else
                {
                    throw new NotImplementedException(String.Format("Creation of {0} interface is not supported yet.", typeof(T)));
                }
        }
    }
}
